/**
  *  \file planetscentral/talk/syntaxini.h
  *  \brief Talk: Syntax Highlighter for INI files
  */
#ifndef C2SERVER_PLANETSCENTRAL_TALK_SYNTAXINI_H
#define C2SERVER_PLANETSCENTRAL_TALK_SYNTAXINI_H

#include "planetscentral/talk/syntax.h"

class SyntaxDatabase;

/** Syntax highlighter for INI files.
    This highlights files like pconfig.src, explmap.cfg, amaster.src, ... */
class SyntaxIni : public SyntaxHighlighter {
 public:
    SyntaxIni(const SyntaxDatabase& db, string_t defaultSection);
    ~SyntaxIni();
    void init(const string_t& str);
    bool scan(Segment& result);

 private:
    const SyntaxDatabase& db;
    string_t section;
    string_t str;
    string_t::size_type pos;

    enum State {
        sBOL,
        sAfterSection,
        sAfterName
    };
    State state;
};

#endif
